src/Entity/Game.php
<?php

namespace App\Entity;

use App\Repository\GameRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=GameRepository::class)
 */
class Game
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=100)
     */
    private $title_game;

    /**
     * @ORM\Column(type="text")
     */
    private $description_game;

    /**
     * @ORM\Column(type="date")
     */
    private $released_at;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $game_cover;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $nb_sell_game;

    /**
     * @ORM\ManyToMany(targetEntity=Type::class, inversedBy="game")
     */
    private $type;

    /**
     * @ORM\ManyToMany(targetEntity=Platform::class, inversedBy="game")
     */
    private $platform;

    /**
     * @ORM\OneToMany(targetEntity=UserHasGame::class, mappedBy="game", orphanRemoval=true)
     */
    private $user_has_game;

    public function __construct()
    {
        $this->type = new ArrayCollection();
        $this->platform = new ArrayCollection();
        $this->user_has_name = new ArrayCollection();
        $this->user_has_game = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitleGame(): ?string
    {
        return $this->title_game;
    }

    public function setTitleGame(string $title_game): self
    {
        $this->title_game = $title_game;

        return $this;
    }

    public function getDescriptionGame(): ?string
    {
        return $this->description_game;
    }

    public function setDescriptionGame(string $description_game): self
    {
        $this->description_game = $description_game;

        return $this;
    }

    public function getReleasedAt(): ?\DateTimeInterface
    {
        return $this->released_at;
    }

    public function setReleasedAt(\DateTimeInterface $released_at): self
    {
        $this->released_at = $released_at;

        return $this;
    }

    public function getGameCover(): ?string
    {
        return $this->game_cover;
    }

    public function setGameCover(?string $game_cover): self
    {
        $this->game_cover = $game_cover;

        return $this;
    }

    public function getNbSellGame(): ?int
    {
        return $this->nb_sell_game;
    }

    public function setNbSellGame(?int $nb_sell_game): self
    {
        $this->nb_sell_game = $nb_sell_game;

        return $this;
    }

    /**
     * @return Collection|type[]
     */
    public function getType(): Collection
    {
        return $this->type;
    }

    public function addType(type $type): self
    {
        if (!$this->type->contains($type)) {
            $this->type[] = $type;
        }

        return $this;
    }

    public function removeType(type $type): self
    {
        $this->type->removeElement($type);

        return $this;
    }

    /**
     * @return Collection|platform[]
     */
    public function getPlatform(): Collection
    {
        return $this->platform;
    }

    public function addPlatform(platform $platform): self
    {
        if (!$this->platform->contains($platform)) {
            $this->platform[] = $platform;
        }

        return $this;
    }

    public function removePlatform(platform $platform): self
    {
        $this->platform->removeElement($platform);

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasName(): Collection
    {
        return $this->user_has_name;
    }

    public function addUserHasName(userhasgame $userHasName): self
    {
        if (!$this->user_has_name->contains($userHasName)) {
            $this->user_has_name[] = $userHasName;
            $userHasName->setGame($this);
        }

        return $this;
    }

    public function removeUserHasName(userhasgame $userHasName): self
    {
        if ($this->user_has_name->removeElement($userHasName)) {
            // set the owning side to null (unless already changed)
            if ($userHasName->getGame() === $this) {
                $userHasName->setGame(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasGame(): Collection
    {
        return $this->user_has_game;
    }

    public function addUserHasGame(userhasgame $userHasGame): self
    {
        if (!$this->user_has_game->contains($userHasGame)) {
            $this->user_has_game[] = $userHasGame;
            $userHasGame->setGame($this);
        }

        return $this;
    }

    public function removeUserHasGame(userhasgame $userHasGame): self
    {
        if ($this->user_has_game->removeElement($userHasGame)) {
            // set the owning side to null (unless already changed)
            if ($userHasGame->getGame() === $this) {
                $userHasGame->setGame(null);
            }
        }

        return $this;
    }
}

src/Entity/Platform.php
<?php

namespace App\Entity;

use App\Repository\PlatformRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PlatformRepository::class)
 */
class Platform
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $name_plat;

    /**
     * @ORM\Column(type="text")
     */
    private $description_plat;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $logo_plat;

    /**
     * @ORM\ManyToMany(targetEntity=Game::class, mappedBy="platform")
     */
    private $game;

    /**
     * @ORM\ManyToMany(targetEntity=UserHasGame::class, mappedBy="platform")
     */
    private $user_has_game;

    public function __construct()
    {
        $this->game = new ArrayCollection();
        $this->user_has_game = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNamePlat(): ?string
    {
        return $this->name_plat;
    }

    public function setNamePlat(string $name_plat): self
    {
        $this->name_plat = $name_plat;

        return $this;
    }

    public function getDescriptionPlat(): ?string
    {
        return $this->description_plat;
    }

    public function setDescriptionPlat(string $description_plat): self
    {
        $this->description_plat = $description_plat;

        return $this;
    }

    public function getLogoPlat(): ?string
    {
        return $this->logo_plat;
    }

    public function setLogoPlat(?string $logo_plat): self
    {
        $this->logo_plat = $logo_plat;

        return $this;
    }

    /**
     * @return Collection|Game[]
     */
    public function getGame(): Collection
    {
        return $this->game;
    }

    public function addGame(Game $game): self
    {
        if (!$this->game->contains($game)) {
            $this->game[] = $game;
            $game->addPlatform($this);
        }

        return $this;
    }

    public function removeGame(Game $game): self
    {
        if ($this->game->removeElement($game)) {
            $game->removePlatform($this);
        }

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasGame(): Collection
    {
        return $this->user_has_game;
    }

    public function addUserHasGame(userhasgame $userHasGame): self
    {
        if (!$this->user_has_game->contains($userHasGame)) {
            $this->user_has_game[] = $userHasGame;
        }

        return $this;
    }

    public function removeUserHasGame(userhasgame $userHasGame): self
    {
        $this->user_has_game->removeElement($userHasGame);

        return $this;
    }
}

src/Entity/Type.php
<?php

namespace App\Entity;

use App\Repository\TypeRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=TypeRepository::class)
 */
class Type
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $title_type;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $description_type;

    /**
     * @ORM\ManyToMany(targetEntity=Game::class, mappedBy="type")
     */
    private $game;

    public function __construct()
    {
        $this->game = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitleType(): ?string
    {
        return $this->title_type;
    }

    public function setTitleType(string $title_type): self
    {
        $this->title_type = $title_type;

        return $this;
    }

    public function getDescriptionType(): ?string
    {
        return $this->description_type;
    }

    public function setDescriptionType(?string $description_type): self
    {
        $this->description_type = $description_type;

        return $this;
    }

    /**
     * @return Collection|Game[]
     */
    public function getGame(): Collection
    {
        return $this->game;
    }

    public function addGame(Game $game): self
    {
        if (!$this->game->contains($game)) {
            $this->game[] = $game;
            $game->addType($this);
        }

        return $this;
    }

    public function removeGame(Game $game): self
    {
        if ($this->game->removeElement($game)) {
            $game->removeType($this);
        }

        return $this;
    }
}

src/Entity/UserHasGame.php
<?php

namespace App\Entity;

use App\Repository\UserHasGameRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=UserHasGameRepository::class)
 */
class UserHasGame
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="datetime")
     */
    private $owned_at;

    /**
     * @ORM\ManyToMany(targetEntity=Platform::class, inversedBy="user_has_game")
     */
    private $platform;

    /**
     * @ORM\ManyToOne(targetEntity=Game::class, inversedBy="user_has_game")
     * @ORM\JoinColumn(nullable=false)
     */
    private $game;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="UserHasGame")
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;

    public function __construct()
    {
        $this->platform = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getOwnedAt(): ?\DateTimeInterface
    {
        return $this->owned_at;
    }

    public function setOwnedAt(\DateTimeInterface $owned_at): self
    {
        $this->owned_at = $owned_at;

        return $this;
    }

    /**
     * @return Collection|Platform[]
     */
    public function getPlatform(): Collection
    {
        return $this->platform;
    }

    public function addPlatform(Platform $platform): self
    {
        if (!$this->platform->contains($platform)) {
            $this->platform[] = $platform;
            $platform->addUserHasGame($this);
        }

        return $this;
    }

    public function removePlatform(Platform $platform): self
    {
        if ($this->platform->removeElement($platform)) {
            $platform->removeUserHasGame($this);
        }

        return $this;
    }

    public function getGame(): ?Game
    {
        return $this->game;
    }

    public function setGame(?Game $game): self
    {
        $this->game = $game;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(?User $user): self
    {
        $this->user = $user;

        return $this;
    }

}

src/Form/UserHasGameType.php
<?php

namespace App\Form;

use App\Entity\Game;
use App\Entity\Platform;
use App\Entity\UserHasGame;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class UserHasGameType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('owned_at', DateType::class, [
                'widget' => 'single_text',
            ])
            ->add('platform', EntityType::class,[
                'class' => Platform::class,
                'choice_label' => 'name_plat',
                'multiple' => true,
                'expanded' => true,
            ])
            ->add('game', EntityType::class,[
                'class' => Game::class,
                'choice_label' => 'title_game',
                'multiple' => false,
                'expanded' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => UserHasGame::class,
        ]);
    }
}

src/Controller/UserHasGameController.php
<?php

namespace App\Controller;

use App\Entity\UserHasGame;
use App\Form\UserHasGameType;
use App\Repository\PlatformRepository;
use App\Repository\TypeRepository;
use App\Repository\UserHasGameRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/mygames")
 */
class UserHasGameController extends AbstractController
{
    /**
     * @Route("/", name="user_has_game_index", methods={"GET"})
     */
    public function index(Request $request, UserHasGameRepository $userHasGameRepository, PlatformRepository $platformRepository, TypeRepository $typeRepository): Response
    {
        $user = $this->getUser();

$test = $request->query->keys();
dump($test);
$test1 = $request->query->get('platform');
dump($test1);

        if ($request->query->keys() !== []) {

            if (($request->query->get('platform') !== null) || ($request->query->get('platform') !== 'all')) {
                $platform = $request->query->get('platform');
            } else {
                $platform = 'all';
            }

            if (($request->get('type') !== null) || ($request->get('type') !== 'all')) {
                $type = $request->get('type');
            } else {
                $type = 'all';
            }

            if ($request->get('order') !== null) {
                $order = $request->get('order');
            } else {
                $order = 'ASC';
            }

            $oui = $userHasGameRepository->findByUserAll($user, $type, $platform, $order);
        } else {
            $oui = $userHasGameRepository->findByUserTitleAsc($user);
        }

        dump($request);
        dump($oui);

        $platforms = $platformRepository->findAll();
        $types = $typeRepository->findAll();

        return $this->render('user_has_game/index.html.twig', [
            'user_has_games' => $oui,
            'platforms' => $platforms,
            'types' => $types,
        ]);
    }

    /**
     * @Route("/new", name="user_has_game_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $userHasGame = new UserHasGame();
        $user = $this->getUser();
        $form = $this->createForm(UserHasGameType::class, $userHasGame);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $userHasGame->setUser($user);

            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($userHasGame);
            $entityManager->flush();

            return $this->redirectToRoute('user_has_game_index');
        }

        return $this->render('user_has_game/new.html.twig', [
            'user_has_game' => $userHasGame,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="user_has_game_show", methods={"GET"})
     */
    public function show(UserHasGame $userHasGame): Response
    {
        return $this->render('user_has_game/show.html.twig', [
            'user_has_game' => $userHasGame,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="user_has_game_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, UserHasGame $userHasGame): Response
    {
        $form = $this->createForm(UserHasGameType::class, $userHasGame);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('user_has_game_index');
        }

        return $this->render('user_has_game/edit.html.twig', [
            'user_has_game' => $userHasGame,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="user_has_game_delete", methods={"POST"})
     */
    public function delete(Request $request, UserHasGame $userHasGame): Response
    {
        if ($this->isCsrfTokenValid('delete'.$userHasGame->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($userHasGame);
            $entityManager->flush();
        }

        return $this->redirectToRoute('user_has_game_index');
    }
}

templates/user_has_game/_delete_form.html.twig
<form method="post" action="{{ path('user_has_game_delete', {'id': user_has_game.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ user_has_game.id) }}">
    <button class="btn">Delete</button>
</form>

templates/user_has_game/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/user_has_game/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit UserHasGame{% endblock %}

{% block body %}
    <h1>Edit UserHasGame</h1>

    {{ include('user_has_game/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('user_has_game_index') }}">back to list</a>

    {{ include('user_has_game/_delete_form.html.twig') }}
{% endblock %}

templates/user_has_game/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}UserHasGame index{% endblock %}

{% block body %}
    <h1>UserHasGame index</h1>

    <form action="" method="get">
        <label for="selectPlat">Select platform</label>
        <select name="platform" id="selectPlat">
            <option value="all">All</option>
        {% for platform in platforms %}
            <option value="{{ platform.namePlat }}">{{ platform.namePlat }}</option>
        {% endfor %}
        </select>
        <br>
        <label for="selectType">Select Type</label>
        <select name="type" id="selectType">
            <option value="all">All</option>
        {% for type in types %}
            <option value="{{ type.titleType }}">{{ type.titleType }}</option>
        {% endfor %}
        </select>
        <br>
        <input type="radio" name="order" id="radio" value="ASC"> <label for="order">title asc</label>
        <input type="radio" name="order" id="radio" value="DESC"> <label for="order">title desc</label>
        <br>
        <input type="submit" value="Send">
    </form>

    <table class="table">
        <thead>
            <tr>
                <th>Title Game</th>
                <th>game Cover</th>
                <th>Owned_at</th>
                <th>Type</th>
                <th>Platform</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for user_has_game in user_has_games %}
            <tr>
                <td>{{ user_has_game.game.titlegame }}</td>
                <td class="mdl-data-table__cell--non-numeric"><img class="logoPlatform" src="../uploads/image/{{ user_has_game.game.gameCover }}" alt=""></td>
                <td>{{ user_has_game.ownedAt ? user_has_game.ownedAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>
                    {% for type in user_has_game.game.type %}
                        {{ type.titleType}}
                    {% endfor %}
                </td>
                <td>
                    {% for plat in user_has_game.platform %}
                        {{ plat.namePlat}}
                    {% endfor %}
                </td>
                <td>
                    <a href="{{ path('user_has_game_show', {'id': user_has_game.id}) }}">show</a>
                    <a href="{{ path('user_has_game_edit', {'id': user_has_game.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="3">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('user_has_game_new') }}">Create new</a>
{% endblock %}

templates/user_has_game/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New UserHasGame{% endblock %}

{% block body %}
    <h1>Create new UserHasGame</h1>

    {{ include('user_has_game/_form.html.twig') }}

    <a href="{{ path('user_has_game_index') }}">back to list</a>
{% endblock %}

templates/user_has_game/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}UserHasGame{% endblock %}

{% block body %}
    <h1>UserHasGame</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ user_has_game.id }}</td>
            </tr>
            <tr>
                <th>Owned_at</th>
                <td>{{ user_has_game.ownedAt ? user_has_game.ownedAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('user_has_game_index') }}">back to list</a>

    <a href="{{ path('user_has_game_edit', {'id': user_has_game.id}) }}">edit</a>

    {{ include('user_has_game/_delete_form.html.twig') }}
{% endblock %}